<%
' Comersus Shopping Cart 
' Comersus Open Technologies
' United States 
' Software License can be found at License.txt
' http://www.comersus.com  
' Details: Stripe Call Back
%>

<!--#include file="../includes/settings.asp"--> 
<!--#include file="../includes/getSettingKey.asp"--> 
<!--#include file="../includes/sessionFunctions.asp"--> 
<!--#include file="../includes/databaseFunctions.asp"-->    
<!--#include file="../includes/stringFunctions.asp"--> 
<!--#include file="../includes/screenMessages.asp"--> 
<!--#include file="../includes/sendMail.asp"--> 
<!--#include file="../includes/miscFunctions.asp"--> 
<!--#include file="../includes/currencyFormat.asp"-->
<!--#include file="../includes/orderFunctions.asp"--> 
<!--#include file="../includes/itemFunctions.asp"-->

<%

dim pAllData, pIdOrder, pTxn_id, pPayment_status, objXMLHTTP, xml, mySQL, conntemp, rstemp, rstemp2, rstemp3

' get settings 

pStoreFrontDemoMode 	= getSettingKey("pStoreFrontDemoMode")
pCurrencySign	 	= getSettingKey("pCurrencySign")
pDecimalSign	 	= getSettingKey("pDecimalSign")
pCompany	 	= getSettingKey("pCompany")
pCompanyLogo	 	= getSettingKey("pCompanyLogo")
pMoneyDontRound	 	= getSettingKey("pMoneyDontRound")
pAuctions		= getSettingKey("pAuctions")
pListBestSellers 	= getSettingKey("pListBestSellers")
pNewsLetter 		= getSettingKey("pNewsLetter")
pPriceList 		= getSettingKey("pPriceList")
pStoreNews 		= getSettingKey("pStoreNews")
pOneStepCheckout	= getSettingKey("pOneStepCheckout")
pEncryptionPassword 	= getSettingKey("pEncryptionPassword")
pUseEncryptedTotal	= getSettingKey("pUseEncryptedTotal")
pStoreLocation		= getSettingKey("pStoreLocation")
pEmailSender		= getSettingKey("pEmailSender")
pEmailAdmin		= getSettingKey("pEmailAdmin")
pSmtpServer		= getSettingKey("pSmtpServer")
pEmailComponent		= getSettingKey("pEmailComponent")
pDebugEmail		= getSettingKey("pDebugEmail")
pOrderPrefix		= getSettingKey("pOrderPrefix")
pSerialCodeOnlyOnce	= getSettingKey("pSerialCodeOnlyOnce")

pStripeSK		= getSettingKey("pStripeSK")

pIdCustomer     	= getSessionVariable("idCustomer","0")

pStripeToken  	 = getUserInput(request.form("stripeToken"),80)
pDataZipCode	 = getUserInput(request.form("data-zip-code"),20)


pAmount		= session("stripeAmount")
pIdOrder	= session("stripeIdOrder")

' extract real idorder (without prefix)
pRealIdOrder 		= removePrefix(pIdOrder,pOrderPrefix)

' create an xmlhttp object
response.buffer = true
set xml 	= Server.CreateObject("Microsoft.XMLHTTP")
 

xml.open "POST", "https://api.stripe.com/v1/charges", false, pStripeSK, "password"
xml.setRequestHeader "Authorization", pStripeSK
xml.send "&amount="&pAmount&"&currency=usd&card="&pStripeToken&"&description=Order "&pIdOrder

' retrieve response
strRetval=xml.responseText

' remove quotes
strRetVal=replace(strRetVal,"""","")

' remove spaces
strRetVal2=replace(strRetVal," ","")

' check notification validation
if instr(strRetVal2,"paid:true")>0 then
 
	pLocateBalancePosition=instr(strRetVal,"balance_transaction")+19
	pAuthorizationCode=mid(strRetVal,pLocateBalancePosition,30)
	
	pStripeReturnedAmountPosition=instr(strRetVal,"amount")+6
	pStripeReturnedAmountEnd=instr(pStripeReturnedAmountPosition,strRetVal,",")
	pStripeReturnedAmount=mid(strRetVal,pStripeReturnedAmountPosition,pStripeReturnedAmountEnd-pStripeReturnedAmountPosition)		
	
	' get database total 
	mySQL="SELECT total, reservationAmount, orderStatus FROM orders WHERE orders.idOrder="&pRealIdOrder

	call getFromDatabase (mySql, rsTemp,"customerShowOrders")

	if not rstemp.eof then
	
		if rstemp("orderStatus")=1 then					
		
			' clear session
			session("stripeAmount")=0
			' mark as paid
			call paymentApproved("Stripe", pIdOrder, pAuthorizationCode)
		else
			response.redirect "comersus_message.asp?message="&Server.Urlencode("Order wasnt pending.")      	
		end if
	
	
	end if ' eof		 	
    	
	response.redirect "comersus_message.asp?message="&Server.Urlencode("Payment for order "&pOrderPrefix&pIdOrder&" received with auth code "&pAuthorizationCode)      	
	
else 
 
 response.redirect "comersus_message.asp?message="&Server.Urlencode("Payment for order "&pIdOrder&" wasnt authorized. Please try again.")      	
 
end if

set xml = nothing

call closeDb()

%>


